unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, onetimepass;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ed2faSeed: TEdit;
    edToken2FA: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    lbRisutato: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function Validazione2FA(const aSeed : String; aCode : Integer) : Boolean;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var Seed2FA: string; Token2FA: integer;
begin
  Token2FA:=StrToInt(edToken2FA.Text);
  Seed2FA:=ed2faSeed.Text;
  if Validazione2FA(Seed2FA, Token2FA) then
     lbRisutato.Caption:='VALIDAZIONE OK!'
  else
     lbRisutato.Caption:='ERRORE DI VALDAZIONE';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ed2faSeed.Text := TOTPSharedSecret();
end;

function TForm1.Validazione2FA(const aSeed: String; aCode: Integer): Boolean;
Var O : LongInt;
begin
   Result:=TOTPValidate(aSeed,aCode,1,O);
end;

end.

